package ru.ulstu.fc.rule.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PostMapping;
import ru.ulstu.fc.rule.model.AddRuleForm;
import ru.ulstu.fc.rule.model.AddTermForm;
import ru.ulstu.fc.rule.service.RuleParseService;

import java.util.List;

@Controller
public class RuleController {
    private final RuleParseService ruleParseService;

    public RuleController(RuleParseService ruleParseService) {
        this.ruleParseService = ruleParseService;
    }

    @GetMapping("addRule")
    public String addRule(Model model) {
        model.addAttribute("addRuleForm", new AddRuleForm());
        return "addRule";
    }

    @PostMapping("addRule")
    public String parse(@ModelAttribute AddRuleForm addRuleForm, Model model) {
        try {
            System.out.println(ruleParseService.parseRules(List.of(addRuleForm.getRule())));
        } catch (Exception ex) {
            return "addRule";
        }
        model.addAttribute("addRuleForm", addRuleForm);
        return "listRules";
    }

    @GetMapping("addTerm")
    public String addTerm(Model model) {
        model.addAttribute("addTermForm", new AddTermForm());
        return "addTerm";
    }

    @PostMapping("addTerm")
    public String parse(@ModelAttribute AddTermForm addTermForm, Model model) {
        model.addAttribute("addTermForm", addTermForm);
        return "listTerms";
    }
}
